# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from noctis_sdk.models.brand_alert import BrandAlert
from typing import Optional, Set
from typing_extensions import Self

class BrandMonitorData(BaseModel):
    """
    Results of a brand monitoring query.
    """ # noqa: E501
    query: Optional[StrictStr] = Field(default=None, description="The original query term(s).")
    exclude: Optional[StrictStr] = Field(default=None, description="The exclusion term(s) used.")
    get_new: Optional[StrictBool] = Field(default=None, description="Indicates if 'new' domains were included.")
    on_hold: Optional[StrictBool] = Field(default=None, description="Indicates if 'on-hold' domains were included.", alias="onHold")
    var_date: Optional[StrictStr] = Field(default=None, description="Date the monitor report was generated for.", alias="date")
    total: Optional[StrictInt] = Field(default=None, description="Total number of alerts found.")
    alerts: Optional[List[BrandAlert]] = Field(default=None, description="List of domain alerts.")
    __properties: ClassVar[List[str]] = ["query", "exclude", "get_new", "onHold", "date", "total", "alerts"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BrandMonitorData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in alerts (list)
        _items = []
        if self.alerts:
            for _item_alerts in self.alerts:
                if _item_alerts:
                    _items.append(_item_alerts.to_dict())
            _dict['alerts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BrandMonitorData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "query": obj.get("query"),
            "exclude": obj.get("exclude"),
            "get_new": obj.get("get_new"),
            "onHold": obj.get("onHold"),
            "date": obj.get("date"),
            "total": obj.get("total"),
            "alerts": [BrandAlert.from_dict(_item) for _item in obj["alerts"]] if obj.get("alerts") is not None else None
        })
        return _obj


