# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from noctis_sdk.models.generic_value_dto_integer import GenericValueDTOInteger
from noctis_sdk.models.generic_value_dto_string import GenericValueDTOString
from typing import Optional, Set
from typing_extensions import Self

class IpInfoWithAsnDTO(BaseModel):
    """
    IP Address information including ASN details.
    """ # noqa: E501
    address: Optional[GenericValueDTOString] = Field(default=None, description="The IP address.")
    asn: Optional[List[GenericValueDTOInteger]] = Field(default=None, description="Autonomous System Number(s) associated with the IP.")
    country_code: Optional[GenericValueDTOString] = Field(default=None, description="Two-letter country code (ISO 3166-1 alpha-2).", alias="countryCode")
    isp: Optional[GenericValueDTOString] = Field(default=None, description="Internet Service Provider or Organization owning the IP block.")
    __properties: ClassVar[List[str]] = ["address", "asn", "countryCode", "isp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IpInfoWithAsnDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in asn (list)
        _items = []
        if self.asn:
            for _item_asn in self.asn:
                if _item_asn:
                    _items.append(_item_asn.to_dict())
            _dict['asn'] = _items
        # override the default output from pydantic by calling `to_dict()` of country_code
        if self.country_code:
            _dict['countryCode'] = self.country_code.to_dict()
        # override the default output from pydantic by calling `to_dict()` of isp
        if self.isp:
            _dict['isp'] = self.isp.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IpInfoWithAsnDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "address": GenericValueDTOString.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "asn": [GenericValueDTOInteger.from_dict(_item) for _item in obj["asn"]] if obj.get("asn") is not None else None,
            "countryCode": GenericValueDTOString.from_dict(obj["countryCode"]) if obj.get("countryCode") is not None else None,
            "isp": GenericValueDTOString.from_dict(obj["isp"]) if obj.get("isp") is not None else None
        })
        return _obj


