# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class IpRangeChange(BaseModel):
    """
    Details of an added or removed IP range.
    """ # noqa: E501
    ip_to: Optional[StrictStr] = Field(default=None, description="End IP of the range.", alias="ipTo")
    organization: Optional[StrictStr] = Field(default=None, description="Organization name associated with the record.")
    record_ip: Optional[StrictStr] = Field(default=None, description="IP address within the range (often start or specific IP).", alias="recordIp")
    record_date: Optional[StrictStr] = Field(default=None, description="Date associated with the record/change.", alias="recordDate")
    range: Optional[StrictStr] = Field(default=None, description="The IP range in CIDR or start-end notation.")
    ip_from: Optional[StrictStr] = Field(default=None, description="Start IP of the range.", alias="ipFrom")
    server: Optional[StrictStr] = Field(default=None, description="Whois server source.")
    country: Optional[StrictStr] = Field(default=None, description="Country code associated with the registration.")
    __properties: ClassVar[List[str]] = ["ipTo", "organization", "recordIp", "recordDate", "range", "ipFrom", "server", "country"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IpRangeChange from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IpRangeChange from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ipTo": obj.get("ipTo"),
            "organization": obj.get("organization"),
            "recordIp": obj.get("recordIp"),
            "recordDate": obj.get("recordDate"),
            "range": obj.get("range"),
            "ipFrom": obj.get("ipFrom"),
            "server": obj.get("server"),
            "country": obj.get("country")
        })
        return _obj


