# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RegistrantAlert(BaseModel):
    """
    A single domain alert from the Registrant Monitor.
    """ # noqa: E501
    domain: Optional[StrictStr] = Field(default=None, description="The domain name involved.")
    match_type: Optional[StrictStr] = Field(default=None, description="How the registrant query matched (e.g., 'current_owner', 'last_owner').", alias="matchType")
    current_owner: Optional[StrictStr] = Field(default=None, description="The current owner/registrant found in the Whois record.", alias="currentOwner")
    created: Optional[StrictStr] = Field(default=None, description="Domain creation date from Whois.")
    modified: Optional[StrictStr] = Field(default=None, description="Domain last modified date from Whois.")
    last_owner: Optional[StrictStr] = Field(default=None, description="The previous owner/registrant (if changed and detected).", alias="lastOwner")
    __properties: ClassVar[List[str]] = ["domain", "matchType", "currentOwner", "created", "modified", "lastOwner"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RegistrantAlert from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RegistrantAlert from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "domain": obj.get("domain"),
            "matchType": obj.get("matchType"),
            "currentOwner": obj.get("currentOwner"),
            "created": obj.get("created"),
            "modified": obj.get("modified"),
            "lastOwner": obj.get("lastOwner")
        })
        return _obj


