# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class VulpraDetectEscalationsRequest(BaseModel):
    """
    Request body for escalating Vulpra Detect domains (e.g., for blocking or external review).
    """ # noqa: E501
    watchlist_domain_ids: List[StrictStr] = Field(description="List of Vulpra Detect domain IDs (obtained from domain list responses) to escalate.", alias="watchlistDomainIds")
    escalation_type: StrictStr = Field(description="The type of escalation to perform.", alias="escalationType")
    app_partner: Optional[StrictStr] = Field(default='NoctisClient', description="Your Product Name (optional, for tracking integrations).", alias="appPartner")
    app_name: Optional[StrictStr] = Field(default='NoctisCore', description="Appliance/Module/Playbook Name (optional, for tracking integrations).", alias="appName")
    app_version: Optional[Union[StrictFloat, StrictInt]] = Field(default=1.0, description="Version of your integration/connector (optional).", alias="appVersion")
    __properties: ClassVar[List[str]] = ["watchlistDomainIds", "escalationType", "appPartner", "appName", "appVersion"]

    @field_validator('escalation_type')
    def escalation_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['blocked', 'google_safe']):
            raise ValueError("must be one of enum values ('blocked', 'google_safe')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VulpraDetectEscalationsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VulpraDetectEscalationsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "watchlistDomainIds": obj.get("watchlistDomainIds"),
            "escalationType": obj.get("escalationType"),
            "appPartner": obj.get("appPartner") if obj.get("appPartner") is not None else 'NoctisClient',
            "appName": obj.get("appName") if obj.get("appName") is not None else 'NoctisCore',
            "appVersion": obj.get("appVersion") if obj.get("appVersion") is not None else 1.0
        })
        return _obj


