# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from noctis_sdk.models.vulpra_enrich_result_dto import VulpraEnrichResultDTO
from typing import Optional, Set
from typing_extensions import Self

class VulpraEnrichData(BaseModel):
    """
    Enrichment data for queried domains.
    """ # noqa: E501
    limit_exceeded: Optional[StrictBool] = Field(default=None, description="Indicates if the query result limit was exceeded (less common for Enrich).", alias="limitExceeded")
    message: Optional[StrictStr] = Field(default=None, description="Optional message related to the query execution.")
    results_count: Optional[StrictInt] = Field(default=None, description="Number of domains successfully enriched in this response.", alias="resultsCount")
    results: Optional[List[VulpraEnrichResultDTO]] = Field(default=None, description="List of enriched domain data.")
    missing_domains: Optional[List[StrictStr]] = Field(default=None, description="List of domains queried but could not be enriched (not found or error).", alias="missingDomains")
    __properties: ClassVar[List[str]] = ["limitExceeded", "message", "resultsCount", "results", "missingDomains"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VulpraEnrichData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in results (list)
        _items = []
        if self.results:
            for _item_results in self.results:
                if _item_results:
                    _items.append(_item_results.to_dict())
            _dict['results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VulpraEnrichData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "limitExceeded": obj.get("limitExceeded"),
            "message": obj.get("message"),
            "resultsCount": obj.get("resultsCount"),
            "results": [VulpraEnrichResultDTO.from_dict(_item) for _item in obj["results"]] if obj.get("results") is not None else None,
            "missingDomains": obj.get("missingDomains")
        })
        return _obj


