# coding: utf-8

"""
    NoctisNet API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class WatchlistUpdateResultDTO(BaseModel):
    """
    Result of updating a single domain's state.
    """ # noqa: E501
    state: Optional[StrictStr] = Field(default=None, description="The new state of the domain.")
    domain: Optional[StrictStr] = Field(default=None, description="The domain name.")
    discovered_date: Optional[StrictStr] = Field(default=None, description="Timestamp when the domain was first discovered.", alias="discoveredDate")
    changed_date: Optional[StrictStr] = Field(default=None, description="Timestamp when the domain's details last changed.", alias="changedDate")
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the domain entry in Vulpra Detect.")
    assigned_by: Optional[StrictStr] = Field(default=None, description="Identifier of the user/system that performed the state update.", alias="assignedBy")
    assigned_date: Optional[StrictStr] = Field(default=None, description="Timestamp when the state update occurred.", alias="assignedDate")
    __properties: ClassVar[List[str]] = ["state", "domain", "discoveredDate", "changedDate", "id", "assignedBy", "assignedDate"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['watched', 'ignored']):
            raise ValueError("must be one of enum values ('watched', 'ignored')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WatchlistUpdateResultDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WatchlistUpdateResultDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "state": obj.get("state"),
            "domain": obj.get("domain"),
            "discoveredDate": obj.get("discoveredDate"),
            "changedDate": obj.get("changedDate"),
            "id": obj.get("id"),
            "assignedBy": obj.get("assignedBy"),
            "assignedDate": obj.get("assignedDate")
        })
        return _obj


