# noctis-sdk
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The `noctis_sdk` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.3
- Package version: 0.0.3
- Generator version: 7.13.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 2.1.0, < 3.0.0
* python-dateutil >= 2.8.2
* pydantic >= 2
* typing-extensions >= 4.7.1

## Getting Started

In your own code, to use this library to connect and interact with noctis-sdk,
you can run the following:

```python

import noctis_sdk
from noctis_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://frog.noctisnet.com
# See configuration.py for a list of all supported configuration parameters.
configuration = noctis_sdk.Configuration(
    host = "https://frog.noctisnet.com"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): bearerAuth
configuration = noctis_sdk.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with noctis_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = noctis_sdk.DNSResolutionApi(api_client)
    name = 'example.com' # str | The domain name to resolve (e.g., example.com)
    type = 'A' # str | The DNS record type to query for (e.g., A, AAAA, CNAME, etc.)

    try:
        # Resolve DNS Query via GET in Wire Format
        api_response = api_instance.resolve_dns_query_get_wire_format(name, type)
        print("The response of DNSResolutionApi->resolve_dns_query_get_wire_format:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DNSResolutionApi->resolve_dns_query_get_wire_format: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://frog.noctisnet.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DNSResolutionApi* | [**resolve_dns_query_get_wire_format**](noctis_sdk/docs/DNSResolutionApi.md#resolve_dns_query_get_wire_format) | **GET** /dns-over-https/resolve-query | Resolve DNS Query via GET in Wire Format
*DNSResolutionApi* | [**resolve_dns_query_post_wire_format**](noctis_sdk/docs/DNSResolutionApi.md#resolve_dns_query_post_wire_format) | **POST** /dns-over-https/resolve-query-bytes | Resolve DNS Query via POST in Wire Format
*FileOperationsApi* | [**add_domains_to_named_list**](noctis_sdk/docs/FileOperationsApi.md#add_domains_to_named_list) | **POST** /file-operations/add-domains-to-list | Add Domains to a Named List
*FileOperationsApi* | [**add_to_domains**](noctis_sdk/docs/FileOperationsApi.md#add_to_domains) | **POST** /file-operations/bulk-domain-resolution | Upload and Add Domains for Bulk Resolution and System Update
*FileOperationsApi* | [**process_url_stream**](noctis_sdk/docs/FileOperationsApi.md#process_url_stream) | **POST** /file-operations/process-url-stream | Processes a stream of URLs to extract and analyze domains
*FileOperationsApi* | [**retrieve_lists_with_stats**](noctis_sdk/docs/FileOperationsApi.md#retrieve_lists_with_stats) | **GET** /file-operations/retrieveListsWithStats | Retrieve all domain lists with their respective statistics
*FileOperationsApi* | [**upload_file_and_explore_domains**](noctis_sdk/docs/FileOperationsApi.md#upload_file_and_explore_domains) | **POST** /file-operations | Upload File to Detect Hostnames and Explore Domain Relationships
*NoctisAccountInformationApi* | [**get_account_information**](noctis_sdk/docs/NoctisAccountInformationApi.md#get_account_information) | **GET** /noctis/v1/account/ | Account Information
*NoctisClassicLookupReversingApi* | [**get_domain_profile**](noctis_sdk/docs/NoctisClassicLookupReversingApi.md#get_domain_profile) | **GET** /noctis/v1/{query}/ | Domain Profile
*NoctisClassicLookupReversingApi* | [**get_domain_risk_score**](noctis_sdk/docs/NoctisClassicLookupReversingApi.md#get_domain_risk_score) | **GET** /noctis/v1/risk/ | Domain Risk Score
*NoctisClassicLookupReversingApi* | [**get_domain_risk_score_evidence**](noctis_sdk/docs/NoctisClassicLookupReversingApi.md#get_domain_risk_score_evidence) | **GET** /noctis/v1/risk/evidence/ | Domain Risk Score Evidence
*NoctisClassicLookupReversingApi* | [**get_parsed_whois**](noctis_sdk/docs/NoctisClassicLookupReversingApi.md#get_parsed_whois) | **GET** /noctis/v1/{query}/whois/parsed | Parsed Whois
*NoctisClassicLookupReversingApi* | [**get_whois_history**](noctis_sdk/docs/NoctisClassicLookupReversingApi.md#get_whois_history) | **GET** /noctis/v1/{query}/whois/history/ | Whois History
*NoctisClassicLookupReversingApi* | [**get_whois_lookup**](noctis_sdk/docs/NoctisClassicLookupReversingApi.md#get_whois_lookup) | **GET** /noctis/v1/{query}/whois/ | Whois Lookup
*NoctisClassicLookupReversingLegacyApi* | [**get_domain_reputation**](noctis_sdk/docs/NoctisClassicLookupReversingLegacyApi.md#get_domain_reputation) | **GET** /noctis/v1/legacy/reputation | Domain Reputation (Legacy)
*NoctisClassicMonitorsApi* | [**get_brand_monitor_alerts**](noctis_sdk/docs/NoctisClassicMonitorsApi.md#get_brand_monitor_alerts) | **GET** /noctis/v1/monitor/brand | Brand Monitor
*NoctisClassicMonitorsApi* | [**get_ip_monitor_alerts**](noctis_sdk/docs/NoctisClassicMonitorsApi.md#get_ip_monitor_alerts) | **GET** /noctis/v1/monitor/ip | IP Monitor
*NoctisClassicMonitorsApi* | [**get_ip_registrant_monitor_alerts**](noctis_sdk/docs/NoctisClassicMonitorsApi.md#get_ip_registrant_monitor_alerts) | **GET** /noctis/v1/monitor/ip-registrant | IP Registrant Monitor
*NoctisClassicMonitorsApi* | [**get_name_server_monitor_alerts**](noctis_sdk/docs/NoctisClassicMonitorsApi.md#get_name_server_monitor_alerts) | **GET** /noctis/v1/monitor/name-server | Name Server Monitor
*NoctisClassicMonitorsApi* | [**get_registrant_monitor_alerts**](noctis_sdk/docs/NoctisClassicMonitorsApi.md#get_registrant_monitor_alerts) | **GET** /noctis/v1/monitor/registrant | Registrant Monitor
*NoctisFeedsApi* | [**list_feed_files**](noctis_sdk/docs/NoctisFeedsApi.md#list_feed_files) | **GET** /noctis/v1/feeds/download | List Feed Files
*NoctisVulpraDetectApi* | [**escalate_domains**](noctis_sdk/docs/NoctisVulpraDetectApi.md#escalate_domains) | **POST** /noctis/v1/vulpra/detect/escalations/ | Escalate Domains
*NoctisVulpraDetectApi* | [**get_ignored_domains**](noctis_sdk/docs/NoctisVulpraDetectApi.md#get_ignored_domains) | **GET** /noctis/v1/vulpra/detect/domains/ignored/ | Ignored Domains
*NoctisVulpraDetectApi* | [**get_new_domains**](noctis_sdk/docs/NoctisVulpraDetectApi.md#get_new_domains) | **GET** /noctis/v1/vulpra/detect/domains/new/ | Newly Discovered Domains
*NoctisVulpraDetectApi* | [**get_watched_domains**](noctis_sdk/docs/NoctisVulpraDetectApi.md#get_watched_domains) | **GET** /noctis/v1/vulpra/detect/domains/watched/ | Watched Domains (Changed/Escalated)
*NoctisVulpraDetectApi* | [**list_monitors**](noctis_sdk/docs/NoctisVulpraDetectApi.md#list_monitors) | **GET** /noctis/v1/vulpra/detect/monitors/ | Monitor List
*NoctisVulpraDetectApi* | [**update_domain_state**](noctis_sdk/docs/NoctisVulpraDetectApi.md#update_domain_state) | **PATCH** /noctis/v1/vulpra/detect/domains/ | Update Domain State (Watch/Ignore)
*NoctisVulpraEnrichApi* | [**enrich_get**](noctis_sdk/docs/NoctisVulpraEnrichApi.md#enrich_get) | **GET** /noctis/v1/vulpra/enrich/ | Vulpra Enrich Query (GET)
*NoctisVulpraEnrichApi* | [**enrich_post**](noctis_sdk/docs/NoctisVulpraEnrichApi.md#enrich_post) | **POST** /noctis/v1/vulpra/enrich/ | Vulpra Enrich Query (POST)
*NoctisVulpraInvestigateApi* | [**investigate_get**](noctis_sdk/docs/NoctisVulpraInvestigateApi.md#investigate_get) | **GET** /noctis/v1/vulpra/investigate/ | Vulpra Investigate Query (GET)
*NoctisVulpraInvestigateApi* | [**investigate_post**](noctis_sdk/docs/NoctisVulpraInvestigateApi.md#investigate_post) | **POST** /noctis/v1/vulpra/investigate/ | Vulpra Investigate Query (POST)
*AsnsApi* | [**compute_asn_ground_truth**](noctis_sdk/docs/AsnsApi.md#compute_asn_ground_truth) | **GET** /score/v1/compute-asn-ground-truth | Compute ASN Ground Truth
*AsnsApi* | [**compute_asn_ground_truth_0**](noctis_sdk/docs/AsnsApi.md#compute_asn_ground_truth_0) | **POST** /score/v1/compute-asn-ground-truth | Compute ASN Ground Truth
*AsnsApi* | [**compute_domain_ground_truth**](noctis_sdk/docs/AsnsApi.md#compute_domain_ground_truth) | **POST** /score/v1/compute-domain-ground-truth | Compute Domain Ground Truth
*AsnsApi* | [**compute_ip_ground_truth1**](noctis_sdk/docs/AsnsApi.md#compute_ip_ground_truth1) | **GET** /score/v1/compute-ip-ground-truth | Compute IP Ground Truth
*AsnsApi* | [**compute_organization_ground_truth**](noctis_sdk/docs/AsnsApi.md#compute_organization_ground_truth) | **POST** /score/v1/compute-prefix-ground-truth | Compute Prefix Ground Truth
*AsnsApi* | [**compute_prefix_ground_truth**](noctis_sdk/docs/AsnsApi.md#compute_prefix_ground_truth) | **GET** /score/v1/compute-prefix-ground-truth | Compute Prefix Ground Truth
*AsnsApi* | [**connection_mapping1**](noctis_sdk/docs/AsnsApi.md#connection_mapping1) | **GET** /score/v1/ConnectionMapping | Maps the network positioning of the given resource.
*AsnsApi* | [**count_list_nodes1**](noctis_sdk/docs/AsnsApi.md#count_list_nodes1) | **GET** /score/v1/count-list-nodes | Count List Nodes
*AsnsApi* | [**enum_sub_domains1**](noctis_sdk/docs/AsnsApi.md#enum_sub_domains1) | **GET** /score/v1/enum_subdomains | Enumerating Basic Subdomains
*AsnsApi* | [**file_uploading**](noctis_sdk/docs/AsnsApi.md#file_uploading) | **POST** /ask/v1 | Detects any hostname in a given file and Explores Domain Relationships
*AsnsApi* | [**find_asn**](noctis_sdk/docs/AsnsApi.md#find_asn) | **GET** /asns/getASN/{asNamePartial} | Find ASNs by part of name or number
*AsnsApi* | [**get_all_tlds**](noctis_sdk/docs/AsnsApi.md#get_all_tlds) | **GET** /asns/getAllTLDs | Retrieve All Top-Level Domains (TLDs)
*AsnsApi* | [**get_asn_listing_rankings**](noctis_sdk/docs/AsnsApi.md#get_asn_listing_rankings) | **GET** /asns/getASNListingRankings | Retrieve Rankings for All ASNs
*AsnsApi* | [**get_asn_listing_statistics**](noctis_sdk/docs/AsnsApi.md#get_asn_listing_statistics) | **GET** /asns/asn/listingStatistics/{asName} | Get ASN Listing Statistics
*AsnsApi* | [**get_similar_domains**](noctis_sdk/docs/AsnsApi.md#get_similar_domains) | **GET** /asns/getSimilarDomains/{domain} | Get similar domains
*AsnsApi* | [**get_similar_ips**](noctis_sdk/docs/AsnsApi.md#get_similar_ips) | **GET** /asns/getSimilarIPs/{ipAddress} | Get similar IP addresses
*AsnsApi* | [**infra_mapping1**](noctis_sdk/docs/AsnsApi.md#infra_mapping1) | **GET** /score/v1/infra-mapping | Retrieve Infrastructure Mapping for Domain
*AsnsApi* | [**list_all_asns**](noctis_sdk/docs/AsnsApi.md#list_all_asns) | **GET** /asns/asns/listAll | Retrieve All Autonomous System Numbers (ASNs)
*AsnsApi* | [**list_all_orgs**](noctis_sdk/docs/AsnsApi.md#list_all_orgs) | **GET** /asns/organizations/listAll | Retrieve All Organizations
*AsnsApi* | [**search_black_list1**](noctis_sdk/docs/AsnsApi.md#search_black_list1) | **GET** /score/v1/black_list_query | Search the blacklist for an entry that matches or includes the input
*DomainsApi* | [**domains_in_same_asn**](noctis_sdk/docs/DomainsApi.md#domains_in_same_asn) | **GET** /domains/domainsInSameASN/{domainName} | Retrieve Domains Within the Same ASN
*DomainsApi* | [**domains_sharing_nameserver**](noctis_sdk/docs/DomainsApi.md#domains_sharing_nameserver) | **GET** /domains/domainsSharingNameserver/{domainName} | Retrieve Domains Sharing Nameservers
*DomainsApi* | [**explore**](noctis_sdk/docs/DomainsApi.md#explore) | **GET** /domains/exploreDomainRelationships/{domainName} | Explore Domain Relationships (Graph Data)
*DomainsApi* | [**find_domains_sharing_mail_host**](noctis_sdk/docs/DomainsApi.md#find_domains_sharing_mail_host) | **GET** /domains/findDomainsSharingMailHost/{domainName} | Retrieve Domains Sharing the Same Mail Host
*DomainsApi* | [**get_asn**](noctis_sdk/docs/DomainsApi.md#get_asn) | **GET** /domains/fetchASNsForDomain/{domainName} | Retrieve Autonomous System Numbers (ASNs) for a Domain
*DomainsApi* | [**get_domain_info_card**](noctis_sdk/docs/DomainsApi.md#get_domain_info_card) | **GET** /domains/getDomainDetails/{domainName} | Retrieve Domain Information Card
*DomainsApi* | [**get_domains_by_same_organisation**](noctis_sdk/docs/DomainsApi.md#get_domains_by_same_organisation) | **GET** /domains/getDomainsBySameOrganisation/{domainName} | Retrieve Domains Under Same Organisation
*DomainsApi* | [**get_domains_on_same_network_prefix**](noctis_sdk/docs/DomainsApi.md#get_domains_on_same_network_prefix) | **GET** /domains/getDomainsOnSameNetworkPrefix/{domainName} | Retrieve Domains on the Same Network Prefix
*DomainsApi* | [**get_linking_domains**](noctis_sdk/docs/DomainsApi.md#get_linking_domains) | **GET** /domains/getLinkingDomains/{domainName} | Retrieve Domains Linking to the Specified Domain
*DomainsApi* | [**get_list_content**](noctis_sdk/docs/DomainsApi.md#get_list_content) | **GET** /domains/getListContent/{listName}/{start} | Retrieve Paginated Content from a Specific List
*DomainsApi* | [**get_list_status**](noctis_sdk/docs/DomainsApi.md#get_list_status) | **GET** /domains/getListStatus | Get Summary of All Lists
*DomainsApi* | [**get_mail_servers**](noctis_sdk/docs/DomainsApi.md#get_mail_servers) | **GET** /domains/getMailServers/{domainName} | Retrieve Mail Servers for a Domain
*DomainsApi* | [**get_nameservers**](noctis_sdk/docs/DomainsApi.md#get_nameservers) | **GET** /domains/getDomainNameservers/{domainName} | Retrieve Nameservers Associated with a Domain
*DomainsApi* | [**have_hosting_on_same_ip**](noctis_sdk/docs/DomainsApi.md#have_hosting_on_same_ip) | **GET** /domains/getDomainsSharingIP/{domainName} | Retrieve Domains Sharing the Same IP Address
*ScoringAlgorithmSrApi* | [**compute_asn_ground_truth1**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#compute_asn_ground_truth1) | **GET** /score/v1sr/compute-asn-ground-truth | Compute ASN Ground Truth
*ScoringAlgorithmSrApi* | [**compute_domain_ground_truth1**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#compute_domain_ground_truth1) | **GET** /score/v1sr/compute-domain-gt | Compute Domain Ground Truth Score
*ScoringAlgorithmSrApi* | [**compute_ip_ground_truth**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#compute_ip_ground_truth) | **GET** /score/v1sr/compute-ip-ground-truth | Compute IP Ground Truth
*ScoringAlgorithmSrApi* | [**compute_organization_ground_truth1**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#compute_organization_ground_truth1) | **GET** /score/v1sr/compute-organization-ground-truth | Compute Organization Ground Truth
*ScoringAlgorithmSrApi* | [**compute_prefix_ground_truth1**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#compute_prefix_ground_truth1) | **GET** /score/v1sr/compute-prefix-ground-truth | Compute Prefix Ground Truth
*ScoringAlgorithmSrApi* | [**compute_registered_prefix_ground_truth**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#compute_registered_prefix_ground_truth) | **GET** /score/v1sr/compute-Registered_prefix-ground-truth | Compute Prefix Ground Truth
*ScoringAlgorithmSrApi* | [**connection_mapping**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#connection_mapping) | **GET** /score/v1sr/ConnectionMapping | Maps the network positioning of the given resource.
*ScoringAlgorithmSrApi* | [**count_list_nodes**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#count_list_nodes) | **GET** /score/v1sr/count-list-nodes | Count List Nodes
*ScoringAlgorithmSrApi* | [**enum_sub_domains**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#enum_sub_domains) | **GET** /score/v1sr/Enum SubDomains | Enumerating Basic Subdomains
*ScoringAlgorithmSrApi* | [**infra_mapping**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#infra_mapping) | **GET** /score/v1sr/infra-mapping | Retrieve Infrastructure Mapping for Domain
*ScoringAlgorithmSrApi* | [**search_black_list**](noctis_sdk/docs/ScoringAlgorithmSrApi.md#search_black_list) | **GET** /score/v1sr/black_list_query | Search the blacklist for an entry that matches or includes the input
*VisualizeApi* | [**explore_ip**](noctis_sdk/docs/VisualizeApi.md#explore_ip) | **GET** /visualize/privacy-policy | Return Privacy Policy for the services
*VisualizeApi* | [**explore_ip_relationships**](noctis_sdk/docs/VisualizeApi.md#explore_ip_relationships) | **GET** /visualize/relationships/ip/{ipAddress} | Explore IP Relationships in Graph Database
*VisualizeApi* | [**generate_cypher_query_from_text**](noctis_sdk/docs/VisualizeApi.md#generate_cypher_query_from_text) | **GET** /visualize/generate-cypher-query/{inputText} | Generate Cypher Query
*VisualizeApi* | [**get_asn_relationships**](noctis_sdk/docs/VisualizeApi.md#get_asn_relationships) | **GET** /visualize/relationships/asn/{asName} | Retrieve ASN Relationships
*VisualizeApi* | [**get_domain_relationships**](noctis_sdk/docs/VisualizeApi.md#get_domain_relationships) | **GET** /visualize/relationships/domain/{domainName} | Retrieve Domain Relationships
*VisualizeApi* | [**retrieve_organization_relationships**](noctis_sdk/docs/VisualizeApi.md#retrieve_organization_relationships) | **GET** /visualize/relationships/organization/{orgName} | Retrieve Organization Relationships


## Documentation For Models

 - [AccountData](noctis_sdk/docs/AccountData.md)
 - [AccountInfo](noctis_sdk/docs/AccountInfo.md)
 - [AccountInformationResponse](noctis_sdk/docs/AccountInformationResponse.md)
 - [BrandAlert](noctis_sdk/docs/BrandAlert.md)
 - [BrandMonitorData](noctis_sdk/docs/BrandMonitorData.md)
 - [BrandMonitorResponse](noctis_sdk/docs/BrandMonitorResponse.md)
 - [ContactDTO](noctis_sdk/docs/ContactDTO.md)
 - [ContactEnrichDTO](noctis_sdk/docs/ContactEnrichDTO.md)
 - [ContactKeys](noctis_sdk/docs/ContactKeys.md)
 - [DomainParsedWhois](noctis_sdk/docs/DomainParsedWhois.md)
 - [DomainProfileData](noctis_sdk/docs/DomainProfileData.md)
 - [DomainProfileResponse](noctis_sdk/docs/DomainProfileResponse.md)
 - [DomainReputationData](noctis_sdk/docs/DomainReputationData.md)
 - [DomainReputationResponse](noctis_sdk/docs/DomainReputationResponse.md)
 - [DomainRiskDTO](noctis_sdk/docs/DomainRiskDTO.md)
 - [DomainRiskScoreData](noctis_sdk/docs/DomainRiskScoreData.md)
 - [DomainRiskScoreEvidenceData](noctis_sdk/docs/DomainRiskScoreEvidenceData.md)
 - [DomainRiskScoreEvidenceResponse](noctis_sdk/docs/DomainRiskScoreEvidenceResponse.md)
 - [DomainRiskScoreResponse](noctis_sdk/docs/DomainRiskScoreResponse.md)
 - [DomainWhoisData](noctis_sdk/docs/DomainWhoisData.md)
 - [EntityTypes](noctis_sdk/docs/EntityTypes.md)
 - [EscalationInfoDTO](noctis_sdk/docs/EscalationInfoDTO.md)
 - [EscalationUpdateResultDTO](noctis_sdk/docs/EscalationUpdateResultDTO.md)
 - [FeedFileDTO](noctis_sdk/docs/FeedFileDTO.md)
 - [FeedListData](noctis_sdk/docs/FeedListData.md)
 - [FeedListResponse](noctis_sdk/docs/FeedListResponse.md)
 - [GenericValueDTOInteger](noctis_sdk/docs/GenericValueDTOInteger.md)
 - [GenericValueDTOLong](noctis_sdk/docs/GenericValueDTOLong.md)
 - [GenericValueDTOString](noctis_sdk/docs/GenericValueDTOString.md)
 - [GenericValueEnrichDTO](noctis_sdk/docs/GenericValueEnrichDTO.md)
 - [HistoryDetail](noctis_sdk/docs/HistoryDetail.md)
 - [HistorySummary](noctis_sdk/docs/HistorySummary.md)
 - [InvestigateResponseData](noctis_sdk/docs/InvestigateResponseData.md)
 - [IpAlert](noctis_sdk/docs/IpAlert.md)
 - [IpBasicDTO](noctis_sdk/docs/IpBasicDTO.md)
 - [IpContact](noctis_sdk/docs/IpContact.md)
 - [IpInfoEnrichDTO](noctis_sdk/docs/IpInfoEnrichDTO.md)
 - [IpInfoWithAsnDTO](noctis_sdk/docs/IpInfoWithAsnDTO.md)
 - [IpMonitorData](noctis_sdk/docs/IpMonitorData.md)
 - [IpMonitorResponse](noctis_sdk/docs/IpMonitorResponse.md)
 - [IpNetwork](noctis_sdk/docs/IpNetwork.md)
 - [IpParsedWhois](noctis_sdk/docs/IpParsedWhois.md)
 - [IpRange](noctis_sdk/docs/IpRange.md)
 - [IpRangeChange](noctis_sdk/docs/IpRangeChange.md)
 - [IpRegistrantMonitorData](noctis_sdk/docs/IpRegistrantMonitorData.md)
 - [IpRegistrantMonitorResponse](noctis_sdk/docs/IpRegistrantMonitorResponse.md)
 - [IpWhoisData](noctis_sdk/docs/IpWhoisData.md)
 - [MonitorDomainCountsDTO](noctis_sdk/docs/MonitorDomainCountsDTO.md)
 - [MxInfoDTO](noctis_sdk/docs/MxInfoDTO.md)
 - [MxInfoEnrichDTO](noctis_sdk/docs/MxInfoEnrichDTO.md)
 - [NameServerAlert](noctis_sdk/docs/NameServerAlert.md)
 - [NameServerBasicDTO](noctis_sdk/docs/NameServerBasicDTO.md)
 - [NameServerHistoryDetail](noctis_sdk/docs/NameServerHistoryDetail.md)
 - [NameServerInfo](noctis_sdk/docs/NameServerInfo.md)
 - [NameServerInfoDTO](noctis_sdk/docs/NameServerInfoDTO.md)
 - [NameServerInfoEnrichDTO](noctis_sdk/docs/NameServerInfoEnrichDTO.md)
 - [NameServerMonitorData](noctis_sdk/docs/NameServerMonitorData.md)
 - [NameServerMonitorResponse](noctis_sdk/docs/NameServerMonitorResponse.md)
 - [ParsedDomainWhoisDetails](noctis_sdk/docs/ParsedDomainWhoisDetails.md)
 - [ParsedIpWhoisDetails](noctis_sdk/docs/ParsedIpWhoisDetails.md)
 - [ProductInfo](noctis_sdk/docs/ProductInfo.md)
 - [RegistrantAlert](noctis_sdk/docs/RegistrantAlert.md)
 - [RegistrantInfo](noctis_sdk/docs/RegistrantInfo.md)
 - [RegistrantMonitorData](noctis_sdk/docs/RegistrantMonitorData.md)
 - [RegistrantMonitorResponse](noctis_sdk/docs/RegistrantMonitorResponse.md)
 - [RegistrarInfo](noctis_sdk/docs/RegistrarInfo.md)
 - [RegistrationInfo](noctis_sdk/docs/RegistrationInfo.md)
 - [RelationshipType](noctis_sdk/docs/RelationshipType.md)
 - [Response](noctis_sdk/docs/Response.md)
 - [RiskComponentEvidence](noctis_sdk/docs/RiskComponentEvidence.md)
 - [RiskComponentScore](noctis_sdk/docs/RiskComponentScore.md)
 - [RiskScoreComponentsDTO](noctis_sdk/docs/RiskScoreComponentsDTO.md)
 - [SeoInfo](noctis_sdk/docs/SeoInfo.md)
 - [ServerInfo](noctis_sdk/docs/ServerInfo.md)
 - [SslInfoDTO](noctis_sdk/docs/SslInfoDTO.md)
 - [SslInfoEnrichDTO](noctis_sdk/docs/SslInfoEnrichDTO.md)
 - [SslSourceInfo](noctis_sdk/docs/SslSourceInfo.md)
 - [TagInfoDTO](noctis_sdk/docs/TagInfoDTO.md)
 - [ThreatProfileScoresDTO](noctis_sdk/docs/ThreatProfileScoresDTO.md)
 - [TrackerInfoDTO](noctis_sdk/docs/TrackerInfoDTO.md)
 - [TripleHashMapStringEntityTypesRelationshipTypeHashMapStringEntityTypes](noctis_sdk/docs/TripleHashMapStringEntityTypesRelationshipTypeHashMapStringEntityTypes.md)
 - [UsageStats](noctis_sdk/docs/UsageStats.md)
 - [VulpraDetectDomainDTO](noctis_sdk/docs/VulpraDetectDomainDTO.md)
 - [VulpraDetectDomainListResponse](noctis_sdk/docs/VulpraDetectDomainListResponse.md)
 - [VulpraDetectDomainsUpdateRequest](noctis_sdk/docs/VulpraDetectDomainsUpdateRequest.md)
 - [VulpraDetectEscalationUpdateResponse](noctis_sdk/docs/VulpraDetectEscalationUpdateResponse.md)
 - [VulpraDetectEscalationsRequest](noctis_sdk/docs/VulpraDetectEscalationsRequest.md)
 - [VulpraDetectMonitorListResponse](noctis_sdk/docs/VulpraDetectMonitorListResponse.md)
 - [VulpraDetectWatchlistUpdateResponse](noctis_sdk/docs/VulpraDetectWatchlistUpdateResponse.md)
 - [VulpraEnrichData](noctis_sdk/docs/VulpraEnrichData.md)
 - [VulpraEnrichResponse](noctis_sdk/docs/VulpraEnrichResponse.md)
 - [VulpraEnrichResultDTO](noctis_sdk/docs/VulpraEnrichResultDTO.md)
 - [VulpraInvestigateResponse](noctis_sdk/docs/VulpraInvestigateResponse.md)
 - [VulpraInvestigateResultDTO](noctis_sdk/docs/VulpraInvestigateResultDTO.md)
 - [VulpraMonitorDTO](noctis_sdk/docs/VulpraMonitorDTO.md)
 - [WatchlistUpdateResultDTO](noctis_sdk/docs/WatchlistUpdateResultDTO.md)
 - [WebsiteData](noctis_sdk/docs/WebsiteData.md)
 - [WhoisContacts](noctis_sdk/docs/WhoisContacts.md)
 - [WhoisHistoryData](noctis_sdk/docs/WhoisHistoryData.md)
 - [WhoisHistoryDetail](noctis_sdk/docs/WhoisHistoryDetail.md)
 - [WhoisHistoryEntry](noctis_sdk/docs/WhoisHistoryEntry.md)
 - [WhoisHistoryResponse](noctis_sdk/docs/WhoisHistoryResponse.md)
 - [WhoisLookupData](noctis_sdk/docs/WhoisLookupData.md)
 - [WhoisLookupResponse](noctis_sdk/docs/WhoisLookupResponse.md)
 - [WhoisRecord](noctis_sdk/docs/WhoisRecord.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication (JWT)


## Author




